#include "Main.h"

#pragma comment(lib, "winmm.lib")
#pragma warning(disable: 4244)

/////////////////////////////
//MINIFMOD CALLBACK FUNCTIONS
/////////////////////////////
unsigned int fileopen(char *name)
{
	return (unsigned int)fopen(name, "rb");
}

void fileclose(unsigned int handle)
{
	fclose((FILE *)handle);
}

int fileread(void *buffer, int size, unsigned int handle)
{
	return fread(buffer, 1, size, (FILE *)handle);
}

void fileseek(unsigned int handle, int pos, signed char mode)
{
	fseek((FILE *)handle, pos, mode);
}

int filetell(unsigned int handle)
{
	return ftell((FILE *)handle);
}
/////////////////////////////
/////////////////////////////
/////////////////////////////


#define EFFECT(fx,time,StartTime,CurTime) \
	StartTime=timeGetTime();CurTime=0; \
	while (CurTime < time) \
	{ \
		if (kbhit()) break; \
		fx; \
		CurTime = timeGetTime() - StartTime; \
	}
		
int main()
{
	FMUSIC_MODULE *mod=NULL;
	int a,b;
	Buffer Output(80,50),Buf1(Output),Buf2(Output),Buf3(Output),Buf4(Output);

	FSOUND_File_SetCallbacks(fileopen, fileclose, fileread, fileseek, filetell);
	if (!FSOUND_Init(44100, 0))
	{
		printf("Error upon initialization\n");
		exit(0);
	}
	// ==========================================================================================
	// LOAD SONG
	// ==========================================================================================
	mod = FMUSIC_LoadSong("CHIP.XM", NULL); //sampleloadcallback);
	if (!mod)
	{
		printf("Error loading song\n");
		exit(0);
	}

	HANDLE Console = InitConsole(Output.Width() , Output.Height(), "Ascii4Ever Again");
	printf("You may press Alt+Enter now or during the intro to toggle Windowed/Fullscreen as you desire\nPress any key to begin\n");
	getch();

	FMUSIC_PlaySong(mod);

	

	while(true)
	{
		Buf1.CreateFromText("    Did you think ASCII was dead... ?     ","Arial",50,FW_BOLD);

		EFFECT( 
				int x=a%415;
				Rotozoom(Buf1, Buf2, 50-a/16.8 , 0, 0, 1.);
				if (x<210) Vortex(Buf2, Output, 40, 25, 30, x/160.);
				else Output.Copy(Buf2, 0, 0);
				Output.OuputChar(Console);,
		13150, b, a);

		Buf1.CreateFromText(" You're  ","Times",25,FW_HEAVY);
		Buf2.CreateFromText(" wrong!! ","Times",25,FW_HEAVY);
		Buf3.Copy(Buf1,0,0);
		Buf3.Copy(Buf2,0,25);
		
		EFFECT( 
				Vortex(Buf3, Output, 40, 25 ,50 , 30.-a/203.);
				Output.OuputChar(Console);,
		6100, b, a);

				
		EFFECT( 				
				Buf3.OuputChar(Console);,
		830, b, a);

		
		EFFECT( 
				int x=a%830;
				if (x<210) Loupe(Buf3, Output, 40, 25, 30, x/160.);
				else if (x>415 && x<625) Loupe(Buf3, Output, 40, 25, 30, 4-x/160.);
				else Output.Copy(Buf3, 0, 0);
				Output.OuputChar(Console);,
		6270, b, a);


		Buf1.CreateFromText(" Antoche ","Times",25,FW_HEAVY);
		Buf2.CreateFromText(" and RR  ","Times",25,FW_HEAVY);
		Buf3.Copy(Buf1,0,0);
		Buf3.Copy(Buf2,0,25);
		Buf1.CreateFromText(" Proudly ","Times",25,FW_HEAVY);
		Buf2.CreateFromText(" present ","Times",25,FW_HEAVY);
		Buf4.Copy(Buf1,0,0);
		Buf4.Copy(Buf2,0,25);

		EFFECT( 
				double x=cos(a/600.);
				if (a<6000) Rotozoom(Buf3, Output, 0, 0, x, 1.);
				else Rotozoom(Buf4, Output, 0, 0, x, 1.);
				Output.OuputChar(Console);,
		13200, b, a);

		Buf3.Clear();
		Buf1.CreateFromText("ASCII4EVER","Copper Black",14,FW_BOLD);
		Buf2.CreateFromText(" AGAIN ! ","Copper Black",20,FW_BOLD);
		Buf1.Colorize(FOREGROUND_RED|FOREGROUND_INTENSITY);
		Buf3.Copy(Buf1,0,0);
		Buf3.Copy(Buf2,0,25);

		EFFECT( 
				double x=cos(a/600.);
				double y=sin(a/300.);
				Vortex(Buf3, Buf4, 23, 33, 22, x/2.+y/2.);
				Loupe(Buf4, Output, x*40.+40, y*25.+25, 20, 3.);
				Output.OuputChar(Console);,
		13200, b, a);


		Buf4.Clear();
		Buf1.CreateFromText("  another  ","Times",20,FW_HEAVY);
		Buf2.CreateFromText("Just For Fun","Arial",16,FW_BOLD);
		Buf3.CreateFromText("      intro  ","Times",20,FW_HEAVY);
		Buf1.Colorize(FOREGROUND_BLUE|FOREGROUND_INTENSITY);
		Buf2.Colorize(FOREGROUND_GREEN|FOREGROUND_INTENSITY);
		Buf3.Colorize(FOREGROUND_BLUE|FOREGROUND_INTENSITY);
		Buf4.Copy(Buf1,0,0);
		Buf4.Copy(Buf2,0,20);
		Buf4.Copy(Buf3,0,33);
		Buf1.Allocate(80,50);
		Buf2.Allocate(80,50);


		EFFECT(;,200,b,a);
		EFFECT( 
				double x=cos(a/415);
				double y=sin(a/830);
				Loupe(Buf4, Output, x*40.+40., y*25.+25., 20, 1.+(a%415)/200.);
				Output.OuputChar(Console);,
		13280, b, a);
		EFFECT( 
				double x=cos(a/415);
				double y=sin(a/830);
				Loupe(Buf4, Buf1, x*40.+40., y*25.+25., 20, 1.+(a%415)/200.);
				Rotozoom(Buf1, Output, 20.-20.*cos(a/207.), 20.-cos(a/830.)*20., sin(a/415.), 1.+sin(a/415.)/2.); 
				Output.OuputChar(Console);,
		13280, b, a);
		EFFECT( 
				double x=cos(a/415);
				double y=sin(a/830);
				Loupe(Buf4, Buf1, x*40.+40., y*25.+25., 20, 1.+(a%415)/200.);
				Rotozoom(Buf1, Buf2, 20.-20.*cos(a/207.), 20.-cos(a/830.)*20., sin(a/415.), 1.+sin(a/415.)/2.); 
				Vortex(Buf2, Output, 40, 25, 25, sin(a/415.)/5.); 
				Output.OuputChar(Console);,
		13280, b, a);

		Buf1.Clear();Buf2.Clear();
		Buf1.CreateFromText("    Greets from Antoche to : Sanx, Med, Mars, Jaylee, RR, and everybody else !          ","Times",25,FW_HEAVY);
		Buf2.CreateFromText("    Greets from RedRibbon to : everybody at LoL Land !","Times",25,FW_HEAVY);
		Buf3.Allocate(max(Buf1.Width(),Buf2.Width()),50);
		Buf3.Clear();
		Buf3.Copy(Buf1, 0, 0);
		Buf3.Copy(Buf2, 0, 25);
		
		EFFECT( 
				Rotozoom(Buf3, Output, 50-a/16.8 , 0, 0, cos(a/2000.)/10.+1.);
				Output.OuputChar(Console);,
		13400, b, a);

		Buf1.CreateFromText("End The ","Monotype Corsiva",28,FW_NORMAL);
		Buf2.Allocate(80,50);
		Buf3.Allocate(80,50);
		Buf3.Clear();
		Buf3.Copy(Buf1, 40, 0);
		EFFECT( 
				Rotozoom(Buf1, Buf2, 40, 25, sin(a/500.)/2., 1.);
				Vortex(Buf2, Output, 40, 25, 40, -sin(a/500.)/2.);
				Output.OuputChar(Console);,
		13360, b, a);

				
		break;
	}

	FMUSIC_FreeSong(mod);
	FSOUND_Close();

	CloseHandle(Console);
	
	return 0;
}


////////////////////////////////
////////////////////////////////
////////////////////////////////

HANDLE InitConsole(int width, int height, char* title)
{
	HANDLE STDOut = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTitle(title);
	COORD size = {width,height};
	SMALL_RECT rect={1,1,width,height};
	CONSOLE_CURSOR_INFO cursorinfos = {2,FALSE};
	SetConsoleWindowInfo(STDOut, TRUE, &rect);
	SetConsoleScreenBufferSize(STDOut, size);
	SetConsoleCursorInfo(STDOut, &cursorinfos);
	return STDOut;
}

void Rotozoom(const Buffer &Source, Buffer &Cible, double centrex, double centrey, double angle, double zoom)
{
	int i,j,k,l;
	double a,r;
	int x,y;

	for (i=0 ; i<Cible.Width() ; i++)
		for (j=0 ; j<Cible.Height() ; j++)
		{
			k=i-centrex;
			l=j-centrey;
			r = sqrt(k*k+l*l)/zoom;
			a = atan2(l,k)-angle;
			x = mod(int(r*cos(a)),Source.Width());
			y = mod(int(r*sin(a)),Source.Height());
			Cible[j][i] = Source[y][x];
		}
}


void Loupe(const Buffer &Source, Buffer &Cible, double centrex, double centrey, double rayon, double zoom)
{
	int i,j,k,l;
	double a,r;
	int x,y;

	for (i=0 ; i<Cible.Width() ; i++)
		for (j=0 ; j<Cible.Height() ; j++)
		{
			k=i-centrex;
			l=j-centrey;
			r = sqrt(k*k+l*l);
			if (r<=rayon)
			{
				a = atan2(l,k);
				r = rayon-(acos( pow(r/rayon,zoom)*2-1 ))*rayon/3.1415;
				x = mod(int(r*cos(a)+centrex),Source.Width());
				y = mod(int(r*sin(a)+centrey),Source.Height());
			}
			else
			{
				x=mod(i,Source.Width());
				y=mod(j,Source.Height());
			}
			Cible[j][i] = Source[y][x];
		}
}

void Vortex(const Buffer &Source, Buffer &Cible, double centrex, double centrey, double rayon, double strength)
{
	int i,j,k,l;
	double a,r;
	int x,y;

	for (i=0 ; i<Cible.Width() ; i++)
		for (j=0 ; j<Cible.Height() ; j++)
		{
			k=i-centrex;
			l=j-centrey;
			r = sqrt(k*k+l*l);
			if (r<=rayon)
			{
				a = atan2(l,k)+acos(r/rayon)*strength;
				x = mod(int(r*cos(a)+centrex),Source.Width());
				y = mod(int(r*sin(a)+centrey),Source.Height());
			}
			else
			{
				x=mod(i,Source.Width());
				y=mod(j,Source.Height());
			}
			Cible[j][i] = Source[y][x];
		}
}

